﻿document.write('<script language=javascript src="../comm/adapter.js"></script>');
document.write('<script language=javascript src="../comm/json2.js"></script>');
var WT_ZQDM = "2102"; 		// 证券代码
var WT_ZQMC = "2103"; 		// 证券名称
var WT_SJJG = "2197"; 		// 申购价格
var WT_JYS = "2108"; 		// 交易市场
var WT_JYS_YHXY = "3018"; 	// 银河信用特殊处理交易市场
var WT_JYS_DH = "2009"; 	// 东海特殊处理交易市场
var WT_SGJG_YH = "2127"; 	// 银河特殊申购价格信用
var WT_CJ_PH = "2163"; 		// 起始配号
var WT_GP_SJSL = "2164"; 	// 成交笔数
var WT_XGLX = "2167"; 		// 新股、股转区分  字段是 6 或者 7 是股转的 其他是新股
var WT_GP_CJBH = "2130";	// 股票成交编号
var WT_GP_CJSL = "2128";	// 股票成交数量
var WT_CJ_CJBS = "2157";   	// 成交笔数
var WT_ZQSL = "2199"; 		// 中签数量
var WT_ZQJE = "2110";		// 中签金额
var WT_GDZH = "2106"; 		// 股东账号
var WT_GP_KYYE = "2121"; 	// 额度
var WT_GP_WTSL = "2126"; 	// 已申购数量
var WT_WTSL = "3016";		// 可申购数量
var WT_RIQI = "2014";		// 日期
var WT_GP_MRJG = "2122";	// 买入价格
var WT_ZQZT = "2630";		// 证券状态
var WT_GP_XZXG = "3000";	// 新债新股区分       
/*
	函数功能:
	获取日期, 参数为0当日日期，负数为当日日期向历史日期推，正数为当日日期向前推
*/
function GetDateStr(AddDayCount) 
{
	var dd = new Date();
	dd.setDate(dd.getDate() + AddDayCount); // 获取AddDayCount天后的日期
	var y = dd.getFullYear();
	var m = dd.getMonth() + 1; 				// 获取当前月份的日期
	var d = dd.getDate();
	m = m < 10 ? "0" + m : m;
	d = d < 10 ? "0" + d : d;
	return y + m + d;
}



/*
*函数功能:
*获取当前日期
*/
function get_cur_date() 
{
	var date = new Date();
	var seperator1 = "-";
	var seperator2 = ":";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if (month >= 1 && month <= 9) 
	{
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) 
	{
		strDate = "0" + strDate;
	}

	var hh = date.getHours();
	var mm = date.getMinutes();
	var ss = date.getSeconds();
	if (hh >= 1 && hh <= 9) 
	{
		hh = "0" + hh;
	}
	if (mm >= 0 && mm <= 9) 
	{
		mm = "0" + mm;
	}

	if (ss >= 0 && ss <= 9)
	{
		ss = "0" + ss;
	}

	return date.getFullYear() + seperator1 + month + seperator1 + strDate + " " + hh + seperator2 + mm + seperator2 + ss;
}

/*
*函数功能:
*获取当前新股的中签结果查询日期
*/
function getDate() 
{
	var date = new Date();
	//var seperator1 = "-";
	//var seperator2 = ":";
	var month = date.getMonth() + 1;
	month = month.toString();
	var strDate = date.getDate();
	strDate = strDate.toString();
	if (month >= 1 && month <= 9) 
	{
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) 
	{
		strDate = "0" + strDate;
	}

	return date.getFullYear()  + month + strDate ;
}

/*
	函数功能:
	输出日志到同花顺软件根目录的zdjyHandle.log
*/
function write_html_log(str) 
{
	fnFunction("test_json", get_cur_date() + ':htmllog:' + str);
}

/*
	函数功能:
	去掉字符串中的\n,\r,/r,/n
*/
function fun_str_replace(str)
{
	var strdes = str;
	strdes = strdes.replace('\n',' ');
	strdes = strdes.replace('\r',' ');
	strdes = strdes.replace('/n',' ');
	strdes = strdes.replace('/r',' ');
	return strdes;
}

/*
*新股列表数组相应索引下标对应值的含义：
*证券代码： WT_ZQDM(2102)
*证券名称： WT_ZQMC(2103)
*申购价格： WT_SJJG(2197)2127
*交易市场： WT_JYS(2108) //华泰这个字段是 市场名称, 需要用名称从客户端取下

*参数说明:
*str     		需要解析的新股信息字符串

*函数功能:
*解析新股列表
*/
function parse_sglist(str) 
{
	var strdes = fun_str_replace(str);			// str是json字符串，strdes是json字符串
	var strToObj = new Function("return" + strdes)();	//strToObj是json对象
	var strAdapter = fn_reply(strToObj, 'parse_sglist');
	var obj = new Function("return" + strAdapter)();

	var parse_array = new Array();
	if (strAdapter.indexOf('code') < 0 || strAdapter.indexOf('data') < 0 || obj.code == undefined || obj.code == "-1" || obj.data == undefined || obj.data.table == undefined) 
	{
		return parse_array;
	}

	for (var i = 0; i < obj.data.table.length; i++) 
	{
		parse_array[i] = new Array();
		parse_array[i][0] = obj.data.table[i][WT_ZQMC]; 		// 证券名称
		parse_array[i][1] = obj.data.table[i][WT_ZQDM]; 		// 申购代码
		parse_array[i][2] = obj.data.table[i][WT_WTSL]; 		// 可申购数量
		parse_array[i][3] = 0; 									// 已申购数量
		parse_array[i][4] = obj.data.table[i][WT_JYS];			// 市场代码
		parse_array[i][5] = obj.data.table[i][WT_SJJG];			// 申购价格
    parse_array[i][6] = obj.data.table[i][WT_ZQZT];			// 证券状态
    parse_array[i][7] = obj.data.table[i][WT_XGLX];			// 新股、股转区分
    parse_array[i][8] = obj.data.table[i][WT_GP_XZXG];		// 新债新股
	}
	return parse_array;
}

/*
*已申购数量数组相应索引下标对应值的含义：
*证券代码： WT_ZQDM(2102)
*已申购数量： WT_GP_WTSL(2126)

*参数说明:
*str     		需要解析的可申购新股信息字符串
*cur_user  		当前用户登录信息(客户端再调用页面的入口函数中，会附带此信息)

*函数功能:
*解析已申购数量
*/
function parse_ywtsl(str) 
{
	var strdes = fun_str_replace(str);
	var strToObj = new Function("return" + strdes)();
	var strAdapter = fn_reply(strToObj, 'parse_ywtsl');
	var obj = new Function("return" + strAdapter)();
	var parse_array = new Array();
	var strObj = window.JSON.stringify(obj);
	if (strAdapter.indexOf('code') < 0 || strAdapter.indexOf('data') < 0 || obj.code == undefined || obj.code == "-1" || obj.data == undefined || obj.data.table == undefined) 
	{
		return parse_array;
	}
	for (var i = 0; i < obj.data.table.length; i++) 
	{
		parse_array[i] = new Array();
		parse_array[i][0] = obj.data.table[i][WT_ZQDM];
		parse_array[i][1] = parseInt(obj.data.table[i][WT_GP_WTSL]);
	}
	return parse_array;
}

/*
*中签明细数组相应索引下标对应值的含义：
*证券代码：WT_ZQDM(2102)
*证券名称：WT_ZQMC(2103)
*中签数量：WT_ZQSL(2199)

*参数说明:
*str     		需要解析的可申购新股信息字符串

*函数功能:
*解析中签明细
*/
function parse_zqmx(str) 
{
	var strdes = fun_str_replace(str);
	var strToObj = new Function("return" + strdes)();
	var strAdapter = fn_reply(strToObj, 'parse_zqmx');
	// alert(JSON.stringify(strAdapter)+'------------strAdapter')
	var obj = new Function("return" + strAdapter)();
	var parse_array = new Array();
	var strObj = window.JSON.stringify(obj);
	if (strAdapter.indexOf('code') < 0 || strAdapter.indexOf('data') < 0 || obj.code == undefined || obj.code == "-1" || obj.data == undefined || obj.data.table == undefined) 
	{
		return parse_array;
	}
	for (var i = 0; i < obj.data.table.length; i++) 
	{
		parse_array[i] = new Array();
		// alert(JSON.stringify(parse_array[i]))
		parse_array[i][0] = obj.data.table[i][WT_ZQMC];
		parse_array[i][1] = obj.data.table[i][WT_ZQSL];
		parse_array[i][2] = obj.data.table[i][WT_GP_MRJG];
        parse_array[i][3] = obj.data.table[i][WT_ZQJE];			// 中签金额
        parse_array[i][4] = obj.data.table[i][WT_RIQI];			// 日期
        parse_array[i][5] = obj.data.table[i][WT_XGLX];			// 新股新债和股转新股区分
        parse_array[i][6] = obj.data.table[i][WT_GP_XZXG];		// 新债新股区分
	}
	return parse_array;
}



/*
*一键申购数组相应索引下标对应值的含义：
*状态值
*申购信息

*参数说明:
*str     		需要解析的可申购新股信息字符串

*函数功能:
*解析用户相关配号
*/
function parse_yijiansg(str) 
{
	//alert("parse_yijiansgaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa:\n"+str);
	var strdes = fun_str_replace(str);

	var strToObj = new Function("return" + strdes)();
	var strAdapter = fn_reply(strToObj, 'parse_yijiansg');
	//alert("strAdapterSSSSSSSS:\n"+strAdapter);
	var obj = new Function("return" + strAdapter)();
	var parse_array = new Array();
	if (strAdapter.indexOf('code') < 0 || obj.code == undefined) 
	{
		parse_array[0] = "-1";
	} else 
	{
		parse_array[0] = obj.code;
	}

	if (strAdapter.indexOf('msg') < 0 || obj.msg == undefined) 
	{
		parse_array[1] = "数据为空字符串请确认";
	} else
	{
		parse_array[1] = obj.msg;
	}
	return parse_array;
}